diff --git a/doc/guides/sample_app_ug/l2_forward_event.rst b/doc/guides/sample_app_ug/l2_forward_event.rst
index 8c519c304..8bdf352c4 100644
--- a/doc/guides/sample_app_ug/l2_forward_event.rst
+++ b/doc/guides/sample_app_ug/l2_forward_event.rst
@@ -66,6 +66,8 @@ where,

 *   --eventq-sched=SCHED_MODE: Event queue schedule mode, Ordered, Atomic or Parallel. Atomic by default.

+*   --config: Configure forwarding port pair mapping. Alternate port pairs by default.
+
 Sample usage commands are given below to run the application into different mode:

 Poll mode with 4 lcores, 16 ports and 8 RX queues per lcore and MAC address updating enabled,
diff --git a/examples/l2fwd-event/l2fwd_common.h b/examples/l2fwd-event/l2fwd_common.h
index 7e33ee749..939221d45 100644
--- a/examples/l2fwd-event/l2fwd_common.h
+++ b/examples/l2fwd-event/l2fwd_common.h
@@ -69,6 +69,7 @@ struct l2fwd_resources {
 	uint8_t sched_type;
 	uint8_t mac_updating;
 	uint8_t rx_queue_per_lcore;
+	bool port_pairs;
 	uint16_t nb_rxd;
 	uint16_t nb_txd;
 	uint32_t enabled_port_mask;
diff --git a/examples/l2fwd-event/main.c b/examples/l2fwd-event/main.c
index 89a6bb9a4..bb71d15ab 100644
--- a/examples/l2fwd-event/main.c
+++ b/examples/l2fwd-event/main.c
@@ -2,6 +2,8 @@
  * Copyright(C) 2019 Marvell International Ltd.
  */

+#include <rte_string_fns.h>
+
 #include "l2fwd_event.h"
 #include "l2fwd_poll.h"

@@ -22,7 +24,9 @@ l2fwd_event_usage(const char *prgname)
 	       "          Default mode = eventdev\n"
 	       "  --eventq-sched: Event queue schedule type, ordered, atomic or parallel.\n"
 	       "                  Default: atomic\n"
-	       "                  Valid only if --mode=eventdev\n\n",
+	       "                  Valid only if --mode=eventdev\n"
+	       "  --config: Configure forwarding port pair mapping\n"
+	       "	    Default: alternate port pairs\n\n",
 	       prgname);
 }

@@ -99,6 +103,69 @@ l2fwd_event_parse_eventq_sched(const char *optarg,
 		rsrc->sched_type = RTE_SCHED_TYPE_PARALLEL;
 }

+static int
+l2fwd_parse_port_pair_config(const char *q_arg, struct l2fwd_resources *rsrc)
+{
+	enum fieldnames {
+		FLD_PORT1 = 0,
+		FLD_PORT2,
+		_NUM_FLD
+	};
+	const char *p, *p0 = q_arg;
+	uint16_t int_fld[_NUM_FLD];
+	char *str_fld[_NUM_FLD];
+	uint16_t port_pair = 0;
+	unsigned int size;
+	char s[256];
+	char *end;
+	int i;
+
+	while ((p = strchr(p0, '(')) != NULL) {
+		++p;
+		p0 = strchr(p, ')');
+		if (p0 == NULL)
+			return -1;
+
+		size = p0 - p;
+		if (size >= sizeof(s))
+			return -1;
+
+		snprintf(s, sizeof(s), "%.*s", size, p);
+		if (rte_strsplit(s, sizeof(s), str_fld,
+					_NUM_FLD, ',') != _NUM_FLD)
+			return -1;
+
+		for (i = 0; i < _NUM_FLD; i++) {
+			errno = 0;
+			int_fld[i] = strtoul(str_fld[i], &end, 0);
+			if (errno != 0 || end == str_fld[i] || int_fld[i] > 255)
+				return -1;
+		}
+
+		if (port_pair >= RTE_MAX_ETHPORTS / 2) {
+			printf("exceeded max number of port pair params: Current %d Max = %d\n",
+			       port_pair, RTE_MAX_ETHPORTS / 2);
+			return -1;
+		}
+
+		if ((rsrc->dst_ports[int_fld[FLD_PORT1]] != UINT32_MAX) ||
+			(rsrc->dst_ports[int_fld[FLD_PORT2]] != UINT32_MAX)) {
+			printf("Duplicate port pair (%d,%d) config\n",
+					int_fld[FLD_PORT1], int_fld[FLD_PORT2]);
+			return -1;
+		}
+
+		rsrc->dst_ports[int_fld[FLD_PORT1]] = int_fld[FLD_PORT2];
+		rsrc->dst_ports[int_fld[FLD_PORT2]] = int_fld[FLD_PORT1];
+
+		port_pair++;
+	}
+
+	rsrc->port_pairs = true;
+
+	return 0;
+}
+
 static const char short_options[] =
 	"p:"  /* portmask */
 	"q:"  /* number of queues */
@@ -109,6 +176,7 @@ static const char short_options[] =
 #define CMD_LINE_OPT_NO_MAC_UPDATING "no-mac-updating"
 #define CMD_LINE_OPT_MODE "mode"
 #define CMD_LINE_OPT_EVENTQ_SCHED "eventq-sched"
+#define CMD_LINE_OPT_PORT_PAIR_CONF "config"

 enum {
 	/* long options mapped to a short option */
@@ -119,12 +187,12 @@ enum {
 	CMD_LINE_OPT_MIN_NUM = 256,
 	CMD_LINE_OPT_MODE_NUM,
 	CMD_LINE_OPT_EVENTQ_SCHED_NUM,
+	CMD_LINE_OPT_PORT_PAIR_CONF_NUM,
 };

 /* Parse the argument given in the command line of the application */
 static int
-l2fwd_event_parse_args(int argc, char **argv,
-		struct l2fwd_resources *rsrc)
+l2fwd_event_parse_args(int argc, char **argv, struct l2fwd_resources *rsrc)
 {
 	int mac_updating = 1;
 	struct option lgopts[] = {
@@ -134,12 +202,19 @@ l2fwd_event_parse_args(int argc, char **argv,
 							CMD_LINE_OPT_MODE_NUM},
 		{ CMD_LINE_OPT_EVENTQ_SCHED, required_argument, NULL,
 						CMD_LINE_OPT_EVENTQ_SCHED_NUM},
+		{ CMD_LINE_OPT_PORT_PAIR_CONF, required_argument, NULL,
+					CMD_LINE_OPT_PORT_PAIR_CONF_NUM},
 		{NULL, 0, 0, 0}
 	};
 	int opt, ret, timer_secs;
 	char *prgname = argv[0];
-	char **argvopt;
+	uint16_t port_id;
 	int option_index;
+	char **argvopt;
+
+	/* reset l2fwd_dst_ports */
+	for (port_id = 0; port_id < RTE_MAX_ETHPORTS; port_id++)
+		rsrc->dst_ports[port_id] = UINT32_MAX;

 	argvopt = argv;
 	while ((opt = getopt_long(argc, argvopt, short_options,
@@ -189,6 +264,15 @@ l2fwd_event_parse_args(int argc, char **argv,
 			l2fwd_event_parse_eventq_sched(optarg, rsrc);
 			break;

+		case CMD_LINE_OPT_PORT_PAIR_CONF_NUM:
+			ret = l2fwd_parse_port_pair_config(optarg, rsrc);
+			if (ret) {
+				printf("Invalid port pair config\n");
+				l2fwd_event_usage(prgname);
+				return -1;
+			}
+			break;
+
 		/* long options */
 		case 0:
 			break;
@@ -209,6 +293,51 @@ l2fwd_event_parse_args(int argc, char **argv,
 	return ret;
 }

+/*
+ * Check port pair config with enabled port mask,
+ * and for valid port pair combinations.
+ */
+static int
+check_port_pair_config(struct l2fwd_resources *rsrc)
+{
+	uint32_t port_pair_mask = 0;
+	uint32_t portid;
+	uint16_t index;
+
+	for (index = 0; index < rte_eth_dev_count_avail(); index++) {
+		if ((rsrc->enabled_port_mask & (1 << index)) == 0)
+			continue;
+
+		portid = rsrc->dst_ports[index];
+		if (portid == UINT32_MAX) {
+			printf("port %u is enabled in but no valid port pair\n",
+			       index);
+			return -1;
+		}
+
+		if (!rte_eth_dev_is_valid_port(index)) {
+			printf("port %u is not valid\n", index);
+			return -1;
+		}
+
+		if (!rte_eth_dev_is_valid_port(portid)) {
+			printf("port %u is not valid\n", portid);
+			return -1;
+		}
+
+		if (port_pair_mask & (1 << portid) &&
+				rsrc->dst_ports[portid] != index) {
+			printf("port %u is used in other port pairs\n", portid);
+			return -1;
+		}
+
+		port_pair_mask |= (1 << portid);
+		port_pair_mask |= (1 << index);
+	}
+
+	return 0;
+}
+
 static int
 l2fwd_launch_one_lcore(void *args)
 {
@@ -465,31 +594,33 @@ main(int argc, char **argv)
 		rte_panic("Invalid portmask; possible (0x%x)\n",
 			(1 << nb_ports) - 1);

-	/* reset l2fwd_dst_ports */
-	for (port_id = 0; port_id < RTE_MAX_ETHPORTS; port_id++)
-		rsrc->dst_ports[port_id] = 0;
-	last_port = 0;
+	if (!rsrc->port_pairs) {
+		last_port = 0;
+		/*
+		 * Each logical core is assigned a dedicated TX queue on each
+		 * port.
+		 */
+		RTE_ETH_FOREACH_DEV(port_id) {
+			/* skip ports that are not enabled */
+			if ((rsrc->enabled_port_mask & (1 << port_id)) == 0)
+				continue;

-	/*
-	 * Each logical core is assigned a dedicated TX queue on each port.
-	 */
-	RTE_ETH_FOREACH_DEV(port_id) {
-		/* skip ports that are not enabled */
-		if ((rsrc->enabled_port_mask & (1 << port_id)) == 0)
-			continue;
+			if (nb_ports_in_mask % 2) {
+				rsrc->dst_ports[port_id] = last_port;
+				rsrc->dst_ports[last_port] = port_id;
+			} else {
+				last_port = port_id;
+			}

+			nb_ports_in_mask++;
+		}
 		if (nb_ports_in_mask % 2) {
-			rsrc->dst_ports[port_id] = last_port;
-			rsrc->dst_ports[last_port] = port_id;
-		} else {
-			last_port = port_id;
+			printf("Notice: odd number of ports in portmask.\n");
+			rsrc->dst_ports[last_port] = last_port;
 		}
-
-		nb_ports_in_mask++;
-	}
-	if (nb_ports_in_mask % 2) {
-		printf("Notice: odd number of ports in portmask.\n");
-		rsrc->dst_ports[last_port] = last_port;
+	} else {
+		if (check_port_pair_config(rsrc) < 0)
+			rte_panic("Invalid port pair config\n");
 	}

 	nb_mbufs = RTE_MAX(nb_ports * (RTE_TEST_RX_DESC_DEFAULT +